-- 每日任务&&周常任务
checkRequire("Lua_TaskActiveItem");
checkRequire("Lua_TaskRewardItem");
Lua_DailyTaskPanel = class("Lua_DailyTaskPanel", Lua_DisplayObject)
function Lua_DailyTaskPanel:ctor(p)
	self:superCall("ctor", p, "DailyTaskPanel_skin");
end

function Lua_DailyTaskPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.activeNum = Lua_NumberImage.new(self.content);
	self.activeNum.pivot = 0;
	self.activeNum.numOffsetX = -2;
	self.activeNum.numAtlas = "number";
	self.activeNum.preStr = "xui_rcrw_number_";
	self.activeNum:setLocation(-208, 355, 0);

	self.activeProgressBar:setMouseEnable(false);
	self.activeProgressBar:setValue(0);

	self.rewardList = Lua_DragList.new(self.content, 607, 756, Lua_AxisDefine.Vertical);
	self.rewardList.tweenId = 2023;
	self.rewardList:setListCell(Lua_TaskRewardItem, 607, 143, 1);
	self.rewardList:setCellSpacing(0, 4);
	self.rewardList:setRectPivot(1);
	self.rewardList:setLocation(0, 270, 0);
end

function Lua_DailyTaskPanel:setPanelType(param)
	self.showType = param;

	-- 设置活跃度抵达某阶段后的奖励item
	local arr = DataCenter.taskUtil.activePointIdsDic[self.showType];
	local len = arr:getSize();
	local startPosX = self.activeProgressBar.posX - self.activeProgressBar.width / 2;
	local deltaPosX = self.activeProgressBar.width / len;
	local curPosX, rewardVo;
	self.activePointRewardArr = Array();
	for i = 1, len do
		curPosX = startPosX + deltaPosX * i;
		rewardVo = Lua_TaskActiveItem.new(self.content);
		rewardVo:setLocation(curPosX, 354, 0);
		rewardVo:setData(arr[i]);
		rewardVo:setLastAndPosX(i == len, curPosX);
		self.activePointRewardArr:add(rewardVo);
	end

	-- 设置进度条的最大数值
	local maxValue = DataCenter.taskData:getActivePointVoByActiveId(arr[len]).active;
	self.activeProgressBar:setMaxValue(maxValue);
end

-- 更新
function Lua_DailyTaskPanel:updateData()
	-- 活跃度变化
	self:updateActivePointReward();

	-- 任务列表
	local idArr = DataCenter.taskData:getTaskIdsByMainType(self.showType);
	self.rewardList:setArrayData(idArr);
end

-- 更新活跃度抵达某阶段的奖励
function Lua_DailyTaskPanel:updateActivePointReward()
	local taskPoint = DataCenter.taskData:getTaskPointByMainType(self.showType);
	self.activeNum.num = taskPoint;
	for i = 1, self.activePointRewardArr:getSize() do
		self.activePointRewardArr[i]:updateRewardState();
	end

	local isChange; -- 进度条是否需要动态渐进
	self.curTargetValue = self:getCurProcessValue(self.showType, taskPoint); -- 当前进度条变化的目标值
	self.showProcessValue = self.showProcessValue or self.curTargetValue;
	if self.showProcessValue >= self.curTargetValue then
		self.activeProgressBar:setValue(self.curTargetValue);
	else
		self:startUpdateProcessValue();
	end
end

-- 根据类型（日常、周常）、活跃度，计算出实际显示的进度条数值
function Lua_DailyTaskPanel:getCurProcessValue(mainType, activePoint)
	local activePointIdsArr = DataCenter.taskUtil.activePointIdsDic[mainType];
	local len = activePointIdsArr:getSize();
	local deltaPoint = DataCenter.taskData:getActivePointVoByActiveId(activePointIdsArr[len]).active / len; -- 平均显示活跃度
	local preValue = 0;
	local nextValue = 0;
	local configPoint; -- 两个阶段之间的配置差值
	local showPoint = 0; -- 显示的活跃度
	for i = 1, len do
		nextValue = DataCenter.taskData:getActivePointVoByActiveId(activePointIdsArr[i]).active;
		preValue = i == 1 and 0 or DataCenter.taskData:getActivePointVoByActiveId(activePointIdsArr[i - 1]).active;
		configPoint = i == 1 and nextValue or nextValue - preValue;
		if activePoint >= nextValue then
			showPoint = showPoint + deltaPoint;
		else
			showPoint = showPoint + deltaPoint * (activePoint - preValue) / configPoint;
			break;
		end
	end
	return showPoint;
end

function Lua_DailyTaskPanel:startUpdateProcessValue()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_DailyTaskPanel", 0.05, self, self.updateProcessValue);
	end
end

function Lua_DailyTaskPanel:updateProcessValue()
	self.showProcessValue = self.showProcessValue + 1;
	if self.showProcessValue >= self.curTargetValue then
		 self:endUpdateProcessValue();
		 self.activeProgressBar:setValue(self.curTargetValue);
	else
		self.activeProgressBar:setValue(self.showProcessValue);
	end
end

function Lua_DailyTaskPanel:endUpdateProcessValue()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateProcessValue);
	end
end

function Lua_DailyTaskPanel:dispose()
	if self.activeNum ~= nil then
		self.activeNum:dispose();
		self.activeNum = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.activePointRewardArr ~= nil then
		self.activePointRewardArr:dispose();
		self.activePointRewardArr = nil;
	end
	self.showProcessValue = nil;
	self:endUpdateProcessValue();
	self:superCall("dispose");
end