Lua_UnlockPrimaryWarWindow = class("Lua_UnlockPrimaryWarWindow", Lua_TipsBaseWindow)
function Lua_UnlockPrimaryWarWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_UnlockPrimaryWarWindow";
end

function Lua_UnlockPrimaryWarWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.contentTxt = UICreate.createLabel(self.content, "", 0, 19, 575, 40, 26);
	self.contentTxt.name = "contentTxt";
	self.contentTxt.alignmentValue = 4;
	self.contentTxt.verticalOverflowValue = 1;
	self.contentTxt.colorStr = Lua_ColorDefine.transColorStr("726763");
end

function Lua_UnlockPrimaryWarWindow:showWin(param)
	self:superCall("showWin", param);

	if param == Lua_TaskData.primaryWarStyle then -- 初级战令
		local list = DataCenter.taskUtil.lockRewardlist;
		self.contentTxt.text = LanUtil.formateStr(202825, spliceIconStrById(list[1]), list[2]);
	else -- 高级战令
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(DataCenter.taskUtil.activeWarRechargeId);
		self.contentTxt.text = LanUtil.formateStr(202826, rechargeInfo.money);
	end
end

function Lua_UnlockPrimaryWarWindow:onSureClick(go)
	if self.showData == Lua_TaskData.primaryWarStyle then
		local list = DataCenter.taskUtil.lockRewardlist;
		local hasCount = DataCenter.packData:getItemCountById(list[1]);
		if hasCount < list[2] then
			DataCenter.packUtil:openPathWindow(list[1]);
		else
			Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskActiveWarUnlockPrimary();
		end
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(DataCenter.taskUtil.activeWarRechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	end
	self:hide();
end

function Lua_UnlockPrimaryWarWindow:dispose()
	if self.contentTxt ~= nil then
		self.contentTxt:dispose();
		self.contentTxt = nil;
	end
	self:superCall("dispose");
end