-- 日常任务功能活跃度抵达某种阶段后的奖励item
Lua_TaskActiveItem = class("Lua_TaskActiveItem", Lua_DisplayObject);
function Lua_TaskActiveItem:ctor(p)
	self:superCall("ctor", p, "TaskActiveItem_skin");
end

function Lua_TaskActiveItem:buildShowItem()
	self:superCall("buildShowItem");

	self.boxIcon:addClickFuntion(self, self.onShowRewardClick);
	self.effectBoxIcon:setEnable(false);
end

function Lua_TaskActiveItem:setData(data)
	self._data = DataCenter.taskData:getActivePointVoByActiveId(data);
	if data == nil or self._data == nil then
		return;
	end

	self.reward = self._data.reward;
	self.curType = self._data.mainType;
	self.activeTxt.text = self._data.active;
end

function Lua_TaskActiveItem:setLastAndPosX(isLast, posX)
	self.isLast = isLast;
	self.rewardPosX = posX;
end

-- 更新活跃度奖励的状态显示
function Lua_TaskActiveItem:updateRewardState()
	self.rewardState = self._data.rewardState;
	if self.rewardState == 0 then -- 不可领取
		self.boxIcon:setAltas(self._data.un_draw[1], self._data.un_draw[2]);
		self.boxIcon.alpha = 1;
		self.effectBoxIcon:setEnable(false);
	elseif self.rewardState == 1 then -- 可领取，改为特效
		self.boxIcon:setAltas(self._data.can_draw[1], self._data.can_draw[2]);
		self.boxIcon.alpha = 0.01;
		self.effectBoxIcon:setAltas(self._data.can_frame[1], self._data.can_frame[2]);
		self.effectBoxIcon:setEnable(false);
	else -- 已领取
		self.boxIcon:setAltas(self._data.has_draw[1], self._data.has_draw[2]);
		self.boxIcon.alpha = 1;
		self.effectBoxIcon:setAltas(self._data.has_frame[1], self._data.has_frame[2]);
		self.effectBoxIcon:setEnable(true);
	end
	self:showBoxEffect(self.rewardState == 1, self._data.can_drwa_effect);
end

function Lua_TaskActiveItem:showBoxEffect(isShow, effectName)
	if isShow then
		local url = "/effects/uiEffects/"..effectName;
		if self.uiEffect == nil then
			self.uiEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.uiEffect:setUrl(url, effectName);
		end
		self.uiEffect:setEnable(false);
		self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_TaskActiveItem:onShowRewardClick()
	if self.rewardState ~= 1 then
		local param = {isLast = self.isLast, rewardPosX = self.rewardPosX, reward = self.reward};
		Lua_WindowUtil.openWin("Lua_TaskActiveRewardWindow", Lua_WinParam.ACTION_OPEN, param);
	else
		self:showBoxEffect(true, "ui_ty_xbx_0101_6");
		Lua_ProxyManager.getProxy("Lua_TaskProxy"):sReceiveTaskReward(self.curType, self._data.id);
	end
end

function Lua_TaskActiveItem:dispose()
	if self.uiEffect ~= nil then
		self.uiEffect:dispose();
		self.uiEffect = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end